/*
 * Copyright (C) 2005, 2007, 2009, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef BASETOOLS_H
# define BASETOOLS_H

# include <string>
# include <vector>
# include <set>

# include "workerdata.h"

/**
 * 
 */
void* createThumbs(void* wd);

/**
 * 
 */
void* copyFiles(void* wd);

class WorkThumbCreate
{
public:
  std::vector<std::string> filelist;
  int                      nMaxW;
  int                      nMaxH;
  float                    flQual; // 0 .. 1.0
  int                      nType;
};

class BaseTools
{
public:
  
  /**
   * returns true if strSuffix is known to indicate a movie file.
   * strSuffix must be lower case and contains the leading dot.
   */
  static bool SuffixIsMovie(std::string& strSuffix);
  
  /**
   * 
   */
  static void getShrinkSize(int w, int h, int& wmax, int& hmax);
  
  /**
   * quality: 0 .. 1.0
   */
  static int createThumb(std::string dest, std::string src, 
                         float quality, int type,
                         int wmax, int hmax);
  
  /**
   * returns 0 if everything is ok
   */
  static int createThumbs(WorkerData* wd);
  
  /**
   * returns 0 if everything is ok
   */
  static int copyFiles(WorkerData* wd);
  
  static std::string getFilePath(std::string relname);

  /**
   * If strc already looks like html, it is returned unchanged. Otherwise it is 
   * converted to html.
   */
  static std::string GetAsHTML(std::string strc);

};


#endif
