/*
 * Copyright (C) 2006, 2009, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "batch.h"

#include <stdlib.h>
#include <iostream>
#include "../shared/platform.h"

#include "pic.h"
#include "treeview.h"

void BatchProc::kw_add(std::vector<ItPicInGroup*> list, std::set<std::string> kwset)
{
  unsigned int size = list.size();
  
  for (unsigned int cnt=0; cnt<size; cnt++)
  {
    ItMeta* pMeta = dynamic_cast<ItMeta*>(list[cnt]->pPic);
    pMeta->kw_add(kwset);
  }
}

void BatchProc::editGimp(std::vector<ItPicInGroup*> list, std::string basepath)
{
  unsigned int size = list.size();

  for (unsigned int cnt=0; cnt<size; cnt++)
  {
    std::string tmp;
    
#ifdef WIN32
    tmp = "gimp \"" + basepath + list[cnt]->pPic->GetPath() + "\"";
#else  
    if (system("which gimp-remote") == 0)
      tmp = "gimp-remote \"" + basepath + list[cnt]->pPic->GetPath() + "\"";
    else if (system("which gimp") == 0)
      tmp = "gimp \"" + basepath + list[cnt]->pPic->GetPath() + "\"";
    else
      tmp = "defaultpaint \"" + basepath + list[cnt]->pPic->GetPath() + "\""; // puppy linux
#endif
    // Note: on some systems this does only work if gimp is already running.
    // In the java version on woody I used 
    //     gimp-remote -n filename
    // which opened a new gimp if needed. Now -n is not 
    // documented anymore!
    std::cout << "command line: " << tmp << "\n";
    Platform::system(tmp);
  }
}

void BatchProc::getPicPath(std::vector<ItPicInGroup*> list,
                           TreeView* data,
                           std::vector<std::string>& srclist, int nSize)
{
  unsigned int size = list.size();
  
  for (unsigned int cnt=0; cnt<size; cnt++)
    srclist.push_back(data->getPicPath(list[cnt]->pPic, nSize));
}

void BatchProc::timeshift(std::vector<ItPicInGroup*> list,
                          int nSec)
{
  unsigned int size = list.size();
  
  for (unsigned int cnt=0; cnt<size; cnt++)
    list[cnt]->pPic->timeshift(nSec);
}

