/*
 * Copyright (C) 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "meta.h"

#include <iostream>
#include "../shared/utf8.h"

void ItMeta::kw_add(std::set<std::string> kwset)
{
  std::string kw = "";
  std::set<std::string>::iterator it;
  
  // merge with current list of keywords in order to not create duplicates
  kw_set(kwset);
  
  it = kwset.begin();
  while (it != kwset.end())
  {
    kw += "," + (*it);
    it++;
  }
  kw += ",";
  SetKeywords(kw.c_str());
}

void ItMeta::kw_replace(std::string from, std::string to, int mode)
{
  //  std::cout << "kw_replace: \"" << from << "\" -> \"" << to << "\"\n";
  std::vector<std::string> kwlist;
  kw_list(kwlist);
  std::vector<std::string>::iterator i = kwlist.begin();
  bool fChanged = false;
  
  while (i != kwlist.end())
  {
    // std::cout << "  " << (*i) << "\n";
    if (mode == 1 && (*i).compare(from) == 0)   // whole word
    {
      *i = to;
      fChanged = true;
    }
    else if (mode == 0 && (*i).find(from) == 0) // beginning is sufficient
    {
      *i = (*i).replace(0, from.length(), to);
      fChanged = true;
    }
    i++;
  }

  if (fChanged)
  {
    std::set<std::string> kwset;
    std::pair<std::set<std::string>::iterator,bool> p;
    std::string out = "";
    
    for (unsigned int n=0; n<kwlist.size(); n++)
    {
      p = kwset.insert(kwlist[n]);
      if (p.second == true)
        out += "," + kwlist[n];
    }  
    out += ",";
    SetKeywords(out);
  }  
}


void ItMeta::kw_fix(std::string& k)
{
  if (k.length())
  {
    if (k[0] != ',')
      k = ',' + k;
    if (k[k.length()-1] != ',')
      k = k + ',';
  }
}

std::string ItMeta::GetKeywordsFile()
{
    // clean up strKeywords
  std::string strKeywordsFile = GetKeywords();
  while (strKeywordsFile.length() && strKeywordsFile[0] == ',')
    strKeywordsFile = strKeywordsFile.substr(1);
  while (strKeywordsFile.length() && strKeywordsFile[strKeywordsFile.length()-1] == ',')
    strKeywordsFile.resize(strKeywordsFile.length()-1);  
  return strKeywordsFile;
}
