// -*- mode: c; mode: fold -*-
//
/*
 * Copyright (C) 2006, 2008, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef PLUGIN_H
# define PLUGIN_H

# include <string>
# include <list>
# include <vector>

class ItPicInGroup;
class TreeView;
class SimpleXMLTransfer;

class Plugin
{
public:
  
  static std::string getPluginList(SimpleXMLTransfer*& xml);
  
  static std::string run(std::vector<ItPicInGroup*> list,
                         SimpleXMLTransfer*     plugin,
                         TreeView*              data);
  
  static std::string getCmds(std::vector<ItPicInGroup*>  list,
                             SimpleXMLTransfer*      plugin,
                             TreeView*               data,
                             std::list<std::string>& vCmds);
  
  static bool match(std::vector<ItPicInGroup*> list,
                    SimpleXMLTransfer*     plugin);
  
private:
  static void loadLists(SimpleXMLTransfer*    plugin,
                        SimpleXMLTransfer*&   blacklist,
                        SimpleXMLTransfer*&   whitelist);
  
  static bool listMatch(SimpleXMLTransfer* list,
                        std::string        name);
  
  static void addPlugins(SimpleXMLTransfer*& xmllist,
                         std::string         newfile);
  
  static void addPlugins(SimpleXMLTransfer*& xmllist,
                         SimpleXMLTransfer*  xFile);
};

#endif
