/*
 * Copyright (C) 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

int sf_true(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  if (*(pStack-1) != 0)
    return 1;
  else
    return 0;  
}

int sf_false(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  if (*(pStack-1) != 0)
    return -1;
  else
    return 0;  
}

int sf_dup(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = *(pStack-1);
  pStack++;
  
  return 0;  
}

int sf_pop(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;
  
  return 0;  
}

int sf_swap(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  intptr_t tmp = *(pStack-1);
  *(pStack-1) = *(pStack-2);
  *(pStack-2) = tmp;
  
  return 0;  
}

int sf_ref_num(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = pContext->pPic->pPic->nRefCnt;
  pStack++;
  
  return 0;  
}

int sf_time(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = pContext->pPic->pPic->getDT().nTime;
  pStack++;
  
  return 0;  
}

int sf_date(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = pContext->pPic->pPic->getDT().nDate;
  pStack++;
  
  return 0;  
}

int sf_key_num(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::set<std::string> kset = Keywords::KeywordList_Set(pContext->pPic->pPic->GetKeywords());  
  *pStack = kset.size();
  pStack++;
  
  return 0;  
}

int sf_NOT(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;
  
  if (*pStack)
    *pStack = 0;
  else
    *pStack = 1;
  
  pStack++;
  
  return 0;  
}

int sf_GREATER(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  int b = *pStack;
  pStack--;  
  int a = *pStack;

  if (a > b)
    *pStack = 1;
  else
    *pStack = 0;
  
  pStack++;
  
  return 0;  
}

int sf_SMALLER(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  int b = *pStack;
  pStack--;  
  int a = *pStack;

  if (a < b)
    *pStack = 1;
  else
    *pStack = 0;
  
  pStack++;
  
  return 0;  
}

int sf_ADD(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  int b = *pStack;
  pStack--;  
  int a = *pStack;

  *pStack = a + b;
  
  pStack++;
  
  return 0;  
}

int sf_MUL(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  int b = *pStack;
  pStack--;  
  int a = *pStack;

  *pStack = a * b;
  
  pStack++;
  
  return 0;  
}

int sf_SUB(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  int b = *(pStack-0);
  int a = *(pStack-1);

  *(pStack-1) = a - b;  
  
  return 0;  
}

int sf_MIN(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  int b = *(pStack-0);
  int a = *(pStack-1);
  
  if (b < a)
    *(pStack-1) = b;
  
  return 0;  
}

int sf_MAX(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  int b = *(pStack-0);
  int a = *(pStack-1);

  if (b > a)
    *(pStack-1) = b;
  
  return 0;  
}

int sf_EQUAL(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;
  int b = *(pStack-0);
  int a = *(pStack-1);
  
  if (a == b)
    *(pStack-1) = 1;
  else
    *(pStack-1) = 0;
  
  return 0;  
}

int sf_CONST(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = arg;  
  pStack++;
  
  return 0;  
}

int sf_str_find(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::string* pA = (std::string*)(*(pStack-1));
  std::string* pB = (std::string*)(arg);
  
  *pStack = *(pStack-1);
  
  if (pA->find(*pB) != std::string::npos)
    *(pStack-1) = 1;
  else
    *(pStack-1) = 0;
  pStack++;
  
  return 0;  
}

int sf_str_count(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::string* pA = (std::string*)(*(pStack-1));
  std::string* pB = (std::string*)(arg);
  std::string::size_type pos;
  
  *pStack = *(pStack-1);
  
  pos = pA->find(*pB);
  if (pos != std::string::npos)
  {
    int cnt = 1;
    std::string::size_type lenB = pB->length();
    std::string::size_type lenA = pA->length();
    while (pos+lenB < lenA && (pos = pA->find(*pB, pos+1)) != std::string::npos)
      cnt++;
    
    *(pStack-1) = cnt;
  }
  else
    *(pStack-1) = 0;
  pStack++;
  
  return 0;  
}

int sf_str_cat(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::string* pA = (std::string*)(*(pStack-1));
  std::string* pB = (std::string*)(*(pStack-2));
  
  pStack--;

  pContext->vStringsTemp[pContext->nTmpStrIdx] = *pA + *pB;
  *(pStack-1) = (intptr_t)(&(pContext->vStringsTemp[pContext->nTmpStrIdx++]));
    
  return 0;  
}

int sf_str_len(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::string* pA = (std::string*)(*(pStack-1));
  *pStack     = *(pStack-1);
  *(pStack-1) = pA->length();
  pStack++;
  
  return 0;  
}

int sf_childof(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::string* pID = (std::string*)(arg);
  if (pContext->pParent)
    *pStack = (pContext->pParent->GetID().compare(*pID) == 0);
  else
    *pStack = 0;
  pStack++;
  
  return 0;  
}

int sf_childof_r(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::string* pID = (std::string*)(arg);
  *pStack = 0;
  ItGroup* p = pContext->pParent;
  while (p)
  {
    if (p->GetID().compare(*pID) == 0)
    {
      *pStack = 1;
      break;
    }
    p = p->pParent;
  }
  pStack++;
  
  return 0;  
}



int sf_key(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = (intptr_t)(pContext->pPic->pPic->GetKeywordsPtr());
  pStack++;
  
  return 0;  
}

int sf_key_l(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->vStringsTemp[pContext->nTmpStrIdx] = UTF8::to_lower(pContext->pPic->pPic->GetKeywords());
  *pStack = (intptr_t)(&(pContext->vStringsTemp[pContext->nTmpStrIdx++]));
  pStack++;
  
  return 0;  
}

int sf_com(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = (intptr_t)(pContext->pPic->pPic->GetCommentPtr());
  pStack++;
  
  return 0;  
}

int sf_com_l(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->vStringsTemp[pContext->nTmpStrIdx] = UTF8::to_lower(pContext->pPic->pPic->GetComment());
  *pStack = (intptr_t)(&(pContext->vStringsTemp[pContext->nTmpStrIdx++]));
  pStack++;
  
  return 0;  
}

int sf_id(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = (intptr_t)(pContext->pPic->pPic->GetIDPtr());
  pStack++;
  
  return 0;  
}

int sf_key_rmdup(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  ItPic* pPic = pContext->pPic->pPic;
  pPic->SetKeywords(Keywords::RemoveDupes(pPic->GetKeywords()));
  
  return 0;  
}



int sf_name(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = (intptr_t)(pContext->pParent->GetNamePtr());
  pStack++;
  
  return 0;  
}

int sf_name_l(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->vStringsTemp[pContext->nTmpStrIdx] = UTF8::to_lower(pContext->pParent->GetName());
  *pStack = (intptr_t)(&(pContext->vStringsTemp[pContext->nTmpStrIdx++]));
  pStack++;
  
  return 0;  
}

int sf_pcom_l(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = (intptr_t)(&(pContext->strPCom));
  pStack++;
  
  return 0;  
}

int sf_pkey_l(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = (intptr_t)(&(pContext->strPKey));
  pStack++;
  
  return 0;  
}

int sf_path(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = (intptr_t)(pContext->pPic->pPic->GetPathPtr());
  pStack++;
  
  return 0;  
}

int sf_file_size(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = FileTools::getSize(pContext->strBasePath + pContext->pPic->pPic->GetPath());
  pStack++;
  
  return 0;  
}

int sf_file_date(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  struct stat     Attribs;
  struct tm       timestruct;    
  FileTools::stat(pContext->strBasePath + pContext->pPic->pPic->GetPath(), &Attribs);
#ifndef WIN32
  localtime_r(&Attribs.st_mtime, &timestruct);
#else
  // todo: is localtime without _r ok?
#endif          
  
  *pStack = JWWDateTime::assembleDate(1900 + timestruct.tm_year, timestruct.tm_mon+1, timestruct.tm_mday);
  pStack++;
  
  return 0;  
}

int sf_file_type(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  std::string strSuf = strL(FileTools::getSuffix(pContext->pPic->pPic->GetPath()));
  
  if (strSuf.compare(".jpg") == 0 ||
      strSuf.compare(".jpeg") == 0 ||
      strSuf.compare(".png") == 0 ||
      strSuf.compare(".xcf") == 0 ||
      strSuf.compare(".tif") == 0 ||
      strSuf.compare(".tiff") == 0 ||
      strSuf.compare(".gif") == 0)
    *pStack = 1; // picture
  else if (BaseTools::SuffixIsMovie(strSuf))
    *pStack = 2; // movie
  else 
    *pStack = 0; // unknown
  
  pStack++;
  
  return 0;  
}

int sf_rate_best(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = 0;
  for (unsigned int n=0; n<pContext->pPic->pPic->vRating.size(); n++)
    if (*pStack < pContext->pPic->pPic->vRating[n])
      *pStack = pContext->pPic->pPic->vRating[n];
  pStack++;
  
  return 0;  
}

int sf_rate_worst(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = ItPic::eRatingBest+1;
  for (unsigned int n=0; n<pContext->pPic->pPic->vRating.size(); n++)
    if (pContext->pPic->pPic->vRating[n] != ItPic::eRatingNone && *pStack > pContext->pPic->pPic->vRating[n])
      *pStack = pContext->pPic->pPic->vRating[n];
  if (*pStack == ItPic::eRatingBest+1)
    *pStack = 0;
  
  pStack++;
  
  return 0;  
}

int sf_rate_mean10(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = 0;
  int num = 0;
  for (unsigned int n=0; n<pContext->pPic->pPic->vRating.size(); n++)
    if (pContext->pPic->pPic->vRating[n] != ItPic::eRatingNone)
    {
      *pStack += pContext->pPic->pPic->vRating[n] * 10;
      num++;
    }
  *pStack /= num;
  pStack++;
  
  return 0;  
}

int sf_rate_num(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = 0;
  for (unsigned int n=0; n<pContext->pPic->pPic->vRating.size(); n++)
    if (pContext->pPic->pPic->vRating[n] != ItPic::eRatingNone)
      (*pStack)++;
  pStack++;
  
  return 0;  
}

int sf_rate_get(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  *pStack = 0;
  if (pContext->pPic->pPic->vRating.size())
    *pStack = pContext->pPic->pPic->vRating[0];
  pStack++;
  
  return 0;  
}

int sf_rate_set(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;  
  if (pContext->pPic->pPic->vRating.size() == 0)
    pContext->pPic->pPic->vRating.resize(1, *pStack);
  else
    pContext->pPic->pPic->vRating[0] = *pStack;
  
  return 0;  
}

int sf_mark_set(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;
  if (*pStack)
    pContext->pPic->fMarked = true;
  
  return 0;  
}

int sf_mark_reset(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;
  if (*pStack)
    pContext->pPic->fMarked = false;
  
  return 0;  
}

int sf_mark_copy(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;
  pContext->pPic->fMarked = (*pStack) != 0;
  
  return 0;  
}


int sf_exif_make(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->ReadExif(pContext->strBasePath + pContext->pPic->pPic->GetPath());  
  pContext->vStringsTemp[pContext->nTmpStrIdx] = pContext->pExif->Get_Make();
  *pStack = (intptr_t)(&(pContext->vStringsTemp[pContext->nTmpStrIdx++]));
  pStack++;  
  return 0;  
}

int sf_exif_model(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->ReadExif(pContext->strBasePath + pContext->pPic->pPic->GetPath());
  pContext->vStringsTemp[pContext->nTmpStrIdx] = pContext->pExif->Get_Model();
  *pStack = (intptr_t)(&(pContext->vStringsTemp[pContext->nTmpStrIdx++]));
  pStack++;
  return 0;  
}

int sf_exif_t(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->ReadExif(pContext->strBasePath + pContext->pPic->pPic->GetPath());
  *pStack = pContext->pExif->Get_ExposureTime_us();
  pStack++;
  return 0;  
}

int sf_exif_f(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->ReadExif(pContext->strBasePath + pContext->pPic->pPic->GetPath());
  *pStack = pContext->pExif->Get_FNumber_m10();
  pStack++;  
  return 0;  
}

int sf_exif_focalLen(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->ReadExif(pContext->strBasePath + pContext->pPic->pPic->GetPath());
  *pStack = pContext->pExif->Get_focalLen();
  pStack++;  
  return 0;  
}

int sf_exif_iso(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->ReadExif(pContext->strBasePath + pContext->pPic->pPic->GetPath());
  *pStack = pContext->pExif->Get_ISO();
  pStack++;    
  return 0;  
}

int sf_exif_date(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pContext->ReadExif(pContext->strBasePath + pContext->pPic->pPic->GetPath());
  std::string strDateTime = pContext->pExif->getDateTime();
  if (strDateTime.length() == 0)
    *pStack = 0;
  else
  {
    JWWDateTime dt;
    dt.setDate(strDateTime.substr(0, 10).c_str());
    *pStack = dt.nDate;
  }
  pStack++;    
  return 0;  
}



/**
 * todo: benennt auch um, wenn die Notation schon korrekt ist (das Datum bereits enthalten).
 * todo: hat mal die Bitrate nicht erkannt. Vielleicht einfach den alten Namen beibehalten,
 *       nur den Teil vor dem ersten Unterstrich mit dem Datum ersetzen?
 *
 * Wenn der letzte Wert auf dem Stack ungleich null ist, wird der Film unbenannt.
 * Wenn der Name mit Datum schon vorhanden war wird eine Null auf den Stack gelegt,
 * ansonsten eine eins.
 * 
 * Beispielhafte Benutzung: sucht Filme, die neuer sind als ein bestimmtes Datum, 
 *                          passt deren Namen an und zeigt sie hinterher an.
 *   : file.type 2 == date 2012-02-19 > * dup jww.rename01
 */
int sf_jww_rename01(intptr_t*& pStack, SearchContext* pContext, intptr_t arg)
{
  pStack--;
  
  int nRenamed = 0;
  if (*pStack && pContext->pPic->pPic->hasDate())
  {
    std::string strPath = pContext->pPic->pPic->GetPath();
    
    std::string strBase = pContext->strBasePath;
    std::string strSuff = FileTools::getSuffix(strPath);
    std::string strName = FileTools::name(strPath);
    strPath = FileTools::path(strPath);
    strName = strName.substr(0, strName.length() - strSuff.length());
    
    // Find part of filename after first underscore:
    std::string strTrailing = "";
    std::string::size_type p1 = strName.find('_');
    if (p1 != std::string::npos)
      strTrailing = strName.substr(p1, strName.length() - p1);
    
    // get date
    std::string strDate;
    {
      JWWDateTime dt = pContext->pPic->pPic->getDT();
      strDate = itoStr(dt.getYear() - 2000, '0', 2)
        + itoStr(dt.getMonth(), '0', 2)
        + itoStr(dt.getDay(), '0', 2);
    }
    
    // date already set?
    if (strDate.compare(strName.substr(0, p1)) != 0)
    {
      std::cout << strDate << "!= '" << strName.substr(0, p1) << "'\n";
      
      // create new filename
      std::string strNeu = strDate + strTrailing;
      if (FileTools::fileExists(strBase + strPath + strNeu + strSuff))
      {
        int nNr = 0;
        strNeu = strDate + strTrailing + "_" + itoStr(nNr, ' ', 1);
        
        while (FileTools::fileExists(strBase + strPath + strNeu + strSuff))
          strNeu = strDate + strTrailing + "_" + itoStr(++nNr, ' ', 1);       
      }
      // rename file
      pContext->pPic->pPic->FileRename(strBase, strPath + strNeu + strSuff);
      nRenamed = 1;
    }    
  }
  
  *pStack = nRenamed;
  pStack++;
  
  return 0;
}

