/*
 * Copyright (C) 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "strsearchgroup.h"

StrSearchGroup::StrSearchGroup(std::string strFlags)
{
  if (strFlags.length() == 0 || strFlags.compare("!") == 0)
    strFlags += "pkpc";
  
  this->strFlags = strFlags;
}

void StrSearchGroup::Add(std::string strWord, bool bNot)
{
  // todo: lowercase?
  if (bNot)
    vStringsNot.push_back(strWord);
  else
    vStrings.push_back(strWord);
}

void StrSearchGroup::AddCond(std::string& strExprOut)
{
  // positives only:
  // pkey.l pcom.l str.cat str.find("") str.find("") str.find("") str.find("") pop * * *
  // 
  // negatives only:
  // pkey.l pcom.l str.cat str.find("") str.find("") str.find("") str.find("") pop + + + !
  // 
  // both:
  // pkey.l pcom.l str.cat str.find("pos") str.find("pos") str.find("neg") str.find("neg") pop + ! * *
  int cnt = -1;
  if (strFlags.find("pk") != std::string::npos)
  {
    strExprOut += " pkey.l";
    cnt++;
  }
  else
  {
    if (strFlags.find("k") != std::string::npos)
    {
      strExprOut += " key.l";
      cnt++;
    }
    if (strFlags.find("K") != std::string::npos)
    {
      strExprOut += " key";
      cnt++;
    }
  }
  if (strFlags.find("pc") != std::string::npos)
  {
    strExprOut += " pcom.l";
    cnt++;
  }
  else
  {
    if (strFlags.find("c") != std::string::npos)
    {
      strExprOut += " com.l";
      cnt++;
    }
    if (strFlags.find("C") != std::string::npos)
    {
      strExprOut += " com";
      cnt++;
    }
  }
  for (; cnt>0; cnt--)
    strExprOut += " str.cat";

  for (unsigned int n=0; n<vStrings.size(); n++)
    strExprOut += " str.find(\"" + vStrings[n] + "\")";
  for (unsigned int n=0; n<vStringsNot.size(); n++)
    strExprOut += " str.find(\"" + vStringsNot[n] + "\")";
  strExprOut += " pop";
  
  if (vStringsNot.size())
  {
    for (unsigned int n=1; n<vStringsNot.size(); n++)
      strExprOut += " +";
    strExprOut += " !";    
  }
  for (unsigned int n=1; n<vStrings.size(); n++)
    strExprOut += " *";
  if (vStrings.size() && vStringsNot.size())
    strExprOut += " *";
}

