/*
 * Copyright (C) 2005, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef WORKERDATA_H
#define WORKERDATA_H

#include "../config.h"

#include <inttypes.h>

class WorkerData
{
  public:
   
   void init(unsigned int todo, void* mywork);
   
   /**
    * This is polled by the worker. Can be externally set to nonzero to
    * stop the worker.
    */ 
   int nStop;
   
   /**
    * This is written by the worker. Will be set to nonzero when
    * the worker finished.
    */
   int nRun;
   
   /**
    * How many units to handle?
    */
   unsigned int uNumToHandle;
   
   /**
    * How many units done?
    */
   unsigned int uNumUnitsDone;

   /**
    * Pointer to something which describes the work to be done
    */
   void* work;
   
   /**
    * 
    */
   intptr_t nRetCode;
   
};
#endif
