/*
 * Copyright (C) 2005, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef XMLDEFS_H
#define XMLDEFS_H

/** 
 * Names of attributes are kept short to keep the datafile small.
 * Additionally there is a different set for loading and saving, to enable
 * simple conversion.
 * Single-characters names reduced the size of a typical unzipped data file 
 * to 63% of its original size. 
 * The gnuzipped one is 89%.
 */

#define CONVERT 0

# define XMLNAME_ITEM     "i"
# define XMLNAME_TYPE     "a"
# define XMLNAME_TITLE    "t"
# define XMLNAME_PATH     "p"
# define XMLNAME_COMMENT  "c"
# define XMLNAME_KEYWORDS "k"
# define XMLNAME_TIME     "z"
# define XMLNAME_DATE     "d"
# define XMLNAME_LINK     "l"

# define XMLNAME_TYPE_GROUP                 "g"
# define XMLNAME_TYPE_GROUPLINKPROPERTIES   "h"
# define XMLNAME_TYPE_PIC                   "p"
# define XMLNAME_TYPE_PICLINK               "q"


#define XMLNAME_ID          "u"
#define XMLNAME_SAVE_ID     XMLNAME_ID

#define XMLNAME_SAVE_ITEM     "i"
#define XMLNAME_SAVE_TYPE     "a"
#define XMLNAME_SAVE_TITLE    "t"
#define XMLNAME_SAVE_PATH     "p"
#define XMLNAME_SAVE_COMMENT  "c"
#define XMLNAME_SAVE_KEYWORDS "k"
#define XMLNAME_SAVE_TIME     "z"
#define XMLNAME_SAVE_DATE     "d"
#define XMLNAME_SAVE_LINK     "l"
#define XMLNAME_SAVE_SEARCH   "s"
#define XMLNAME_SAVE_FLAGS    "f"

#endif
