/*
 * Copyright (C) 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef CACHE_H
# define CACHE_H

#include <string>
#include <list>
# include <FL/Fl_Image.H>
#include "../shared/filetools.h"

class CachedPic
{
public:
  
  CachedPic(std::string strSrc, std::string strDst, int nw, int nh, int nQualOverSpeed)
  {
    strPathSrc = strSrc;
    strPathCache = strDst;
    wmax = nw;
    hmax = nh;
    size = 0;
    nQual = nQualOverSpeed;
  };
  
  ~CachedPic();
  
  void Save(Fl_RGB_Image* pImg);

  Fl_RGB_Image* Load();
  
  bool fits(std::string npath, int nw, int nh, int nQual);
  
  std::string strPathSrc;
  std::string strPathCache;
  int wmax;
  int hmax;
  int pic_w,pic_h,pic_d;
  int size;
  int nQual;
};


class PicCache
{
public:
  
  /**
   * a directory will be created inside of strCacheDir
   */
  PicCache(int nCacheBytes);
  ~PicCache();
  
  /**
   * Returns a CachedPic. If its size is zero, its file needs to be created.
   */
  CachedPic* Request(std::string strPath, int w, int h, int nQual);
  
  // std::string GetCacheDir() { return(strCacheDir); };
  
private:  
  std::string strCacheDir;
  std::list<CachedPic*> liste;
  int nName;
  int nCacheBytes;
};

#endif
