/*
 * Copyright (C) 2006  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef __DATESELECT_H
#define __DATESELECT_H

#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Select_Browser.H>

class DateSelect
{
  public:
   DateSelect(int* year, 
              int* month, 
              int* day);
   ~DateSelect();
   
  private:
   int dow_fdom;
   int week_fdom;
   
   int* pnYear;
   int* pnMonth;
   int* pnDay;
   
   int nDYear;
   int nDMonth;
   
   int nTDay;
   int nTMonth;
   int nTYear;

   char mStr[3];
   char yStr[5];
   
   Fl_Box* monthBox;
   Fl_Box* yearBox;
   
   
   Fl_Window*  win;
   Fl_Button*  doneB;
   
   Fl_Select_Browser* monthView;
   
   inline void cb_Window_i(Fl_Window*, void*);
   static void cb_Window(Fl_Window*, void*);   

   inline void cb_Cancel_i(Fl_Button*, void*);
   static void cb_Cancel(Fl_Button*, void*);   

   inline void cb_Done_i(Fl_Button*, void*);
   static void cb_Done(Fl_Button*, void*);

   inline void cb_Year_i(Fl_Button*, void*);
   static void cb_Year(Fl_Button*, void*);

   inline void cb_Month_i(Fl_Button*, void*);
   static void cb_Month(Fl_Button*, void*);

   inline void cb_MonthView_i(Fl_Select_Browser*, void*);
   static void cb_MonthView(Fl_Select_Browser*, void*);

   void dispMonYear();
   void dispMonth();
   
  public:
   void show();
   void hide();
   int visible();
};


#endif
