/*
 * Copyright (C) 2006-2007, 2011-2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "exportdlg.h"
#include "../base/export.h"
#include "../base/treeview.h"
#include "../shared/lib_conversions.h"

#include <iostream>
#include <FL/Fl_File_Chooser.H>


Fl_Double_Window* ExportDlg::make_window()
{
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(760, 445, "Export options");
    w = o;
    o->user_data((void*)(this));
    { Fl_Group* o = new Fl_Group(10, 30, 320, 105, "Copy or shrink pictures?");
      o->box(FL_ENGRAVED_FRAME);
      o->align(FL_ALIGN_TOP_LEFT);
      { sw_shrink = new Fl_Check_Button(20, 39, 250, 30, "Shrink picture files");
        sw_shrink->down_box(FL_DOWN_BOX);
      } // Fl_Check_Button* sw_shrink
      { cb_size_pic = new Fl_Choice(20, 94, 120, 30, "Max. size");
        cb_size_pic->box(FL_FLAT_BOX);
        cb_size_pic->down_box(FL_BORDER_BOX);
        cb_size_pic->color(FL_BACKGROUND_COLOR);
        cb_size_pic->selection_color(FL_SELECTION_COLOR);
        cb_size_pic->labeltype(FL_NORMAL_LABEL);
        cb_size_pic->labelfont(0);
        cb_size_pic->labelsize(14);
        cb_size_pic->labelcolor(FL_FOREGROUND_COLOR);
        cb_size_pic->align(FL_ALIGN_TOP_LEFT);
        cb_size_pic->when(FL_WHEN_RELEASE);
      } // Fl_Choice* cb_size_pic
      { sl_qual_pic = new Fl_Value_Slider(185, 94, 135, 30, "jpeg quality");
        sl_qual_pic->box(FL_DOWN_BOX);
        sl_qual_pic->color(FL_BACKGROUND_COLOR);
        sl_qual_pic->selection_color(FL_BACKGROUND_COLOR);
        sl_qual_pic->labeltype(FL_NORMAL_LABEL);
        sl_qual_pic->labelfont(0);
        sl_qual_pic->labelsize(14);
        sl_qual_pic->labelcolor(FL_FOREGROUND_COLOR);
        sl_qual_pic->textsize(14);
        sl_qual_pic->align(FL_ALIGN_TOP_LEFT);
        sl_qual_pic->when(FL_WHEN_CHANGED);
      } // Fl_Value_Slider* sl_qual_pic
      o->end();
    } // Fl_Group* o
    { gr_thumb = new Fl_Group(375, 30, 290, 75, "Thumbnails (html export)");
      gr_thumb->box(FL_ENGRAVED_FRAME);
      gr_thumb->align(FL_ALIGN_TOP_LEFT);
      { cb_size_thumb = new Fl_Choice(385, 61, 120, 30, "Size");
        cb_size_thumb->box(FL_FLAT_BOX);
        cb_size_thumb->down_box(FL_BORDER_BOX);
        cb_size_thumb->color(FL_BACKGROUND_COLOR);
        cb_size_thumb->selection_color(FL_SELECTION_COLOR);
        cb_size_thumb->labeltype(FL_NORMAL_LABEL);
        cb_size_thumb->labelfont(0);
        cb_size_thumb->labelsize(14);
        cb_size_thumb->labelcolor(FL_FOREGROUND_COLOR);
        cb_size_thumb->align(FL_ALIGN_TOP_LEFT);
        cb_size_thumb->when(FL_WHEN_RELEASE);
      } // Fl_Choice* cb_size_thumb
      { sl_qual_thumb = new Fl_Value_Slider(520, 61, 135, 30, "jpeg quality");
        sl_qual_thumb->box(FL_DOWN_BOX);
        sl_qual_thumb->color(FL_BACKGROUND_COLOR);
        sl_qual_thumb->selection_color(FL_BACKGROUND_COLOR);
        sl_qual_thumb->labeltype(FL_NORMAL_LABEL);
        sl_qual_thumb->labelfont(0);
        sl_qual_thumb->labelsize(14);
        sl_qual_thumb->labelcolor(FL_FOREGROUND_COLOR);
        sl_qual_thumb->textsize(14);
        sl_qual_thumb->align(FL_ALIGN_TOP_LEFT);
        sl_qual_thumb->when(FL_WHEN_CHANGED);
      } // Fl_Value_Slider* sl_qual_thumb
      gr_thumb->end();
    } // Fl_Group* gr_thumb
    { sw_html = new Fl_Check_Button(10, 148, 260, 25, "html export");
      sw_html->down_box(FL_DOWN_BOX);
    } // Fl_Check_Button* sw_html
    { sw_fast = new Fl_Check_Button(10, 178, 350, 30, "Shrink/thumbnails: fast preview conversion");
      sw_fast->down_box(FL_DOWN_BOX);
    } // Fl_Check_Button* sw_fast
    { sw_recurse = new Fl_Check_Button(10, 213, 225, 25, "Copy groups recursively");
      sw_recurse->down_box(FL_DOWN_BOX);
    } // Fl_Check_Button* sw_recurse
    { sw_thumbs = new Fl_Check_Button(10, 243, 180, 25, "Include thumbnails");
      sw_thumbs->down_box(FL_DOWN_BOX);
    } // Fl_Check_Button* sw_thumbs
    { sw_datafile = new Fl_Check_Button(375, 148, 240, 25, "Create datafile");
      sw_datafile->down_box(FL_DOWN_BOX);
    } // Fl_Check_Button* sw_datafile
    { sw_addtojpeg = new Fl_Check_Button(375, 178, 260, 25, "Add comment/keywords to jpeg file");
      sw_addtojpeg->down_box(FL_DOWN_BOX);
    } // Fl_Check_Button* sw_addtojpeg
    { gr_hier = new Fl_Group(10, 295, 355, 140, "Output hierarchy and names");
      gr_hier->box(FL_ENGRAVED_FRAME);
      gr_hier->align(FL_ALIGN_TOP_LEFT);
      { rb_flat = new Fl_Round_Button(20, 305, 220, 25, "Flat");
        rb_flat->type(102);
        rb_flat->down_box(FL_ROUND_DOWN_BOX);
      } // Fl_Round_Button* rb_flat
      { rb_filesys = new Fl_Round_Button(20, 335, 240, 25, "Structured: filesystem");
        rb_filesys->type(102);
        rb_filesys->down_box(FL_ROUND_DOWN_BOX);
      } // Fl_Round_Button* rb_filesys
      { rb_view = new Fl_Round_Button(20, 365, 235, 25, "Structured: fotoalbum view");
        rb_view->type(102);
        rb_view->down_box(FL_ROUND_DOWN_BOX);
      } // Fl_Round_Button* rb_view
      { sw_prefix = new Fl_Check_Button(20, 400, 290, 25, "Filename prefix (sort order)");
        sw_prefix->down_box(FL_DOWN_BOX);
      } // Fl_Check_Button* sw_prefix
      gr_hier->end();
    } // Fl_Group* gr_hier
    { disp_dir = new Fl_Output(375, 295, 265, 30, "Output directory");
      disp_dir->align(FL_ALIGN_TOP_LEFT);
    } // Fl_Output* disp_dir
    { bt_browse = new Fl_Button(650, 295, 100, 30, "Browse...");
    } // Fl_Button* bt_browse
    { bt_cancel = new Fl_Button(476, 395, 130, 40, "Cancel");
    } // Fl_Button* bt_cancel
    { bt_ok = new Fl_Return_Button(620, 395, 130, 40, "Export");
    } // Fl_Return_Button* bt_ok
    o->end();
  } // Fl_Double_Window* o
  return w;
}

void cb_dir(Fl_Widget* widget, void* userdata)    
{
  Fl_Output* output = (Fl_Output*)userdata;

  char* destptr;
  
  destptr = fl_dir_chooser("Output directory", output->value());
  
  if (destptr != (char*)0)
    output->value(destptr);
}

void cb_hide_show(Fl_Widget* widget, void* userdata)    
{
  ExportDlg* dlg = (ExportDlg*)userdata;
  
  if (dlg->sw_shrink->value())
  {
    dlg->cb_size_pic->activate();
    dlg->sl_qual_pic->activate();
  }
  else
  {
    dlg->cb_size_pic->deactivate();
    dlg->sl_qual_pic->deactivate();
  }
  
  if (dlg->sw_html->value())
  {
    dlg->gr_thumb->activate();
    dlg->cb_size_thumb->activate();
    dlg->sl_qual_thumb->activate();
    
    dlg->gr_hier->deactivate();
    dlg->rb_flat->deactivate();
    dlg->rb_filesys->deactivate();
    dlg->rb_view->deactivate();
    dlg->sw_prefix->deactivate();
    dlg->sw_thumbs->deactivate();
  }
  else
  {
    dlg->gr_thumb->deactivate();
    dlg->cb_size_thumb->deactivate();
    dlg->sl_qual_thumb->deactivate();
    
    dlg->gr_hier->activate();
    dlg->rb_flat->activate();
    dlg->rb_filesys->activate();
    dlg->rb_view->activate();
    dlg->sw_thumbs->activate();
    
    if (dlg->rb_view->value())
      dlg->sw_prefix->activate();
    else
      dlg->sw_prefix->deactivate();
  }
  
  if (dlg->sw_html->value() || dlg->sw_shrink->value())
    dlg->sw_fast->activate();
  else
    dlg->sw_fast->deactivate();
  
  if (dlg->fGroup)
    dlg->sw_recurse->activate();
  else
    dlg->sw_recurse->deactivate();  
}

ExportDlg::ExportDlg(T_optionen* myopts, bool fGroup)
{
  opts = myopts;

  myWindow = make_window();
  myWindow->user_data((void*)(this));
  
  myWindow->end();
  
  SimpleXMLTransfer* tmp;
  
  tmp = opts->pool->getChild("export");
  switch (tmp->attributeAsInt("type"))
  {
   case Export::eCopy:
    sw_shrink->value(0);
    break;
   default:
    sw_shrink->value(1);
    break;
  }
  
  {
    SimpleXMLTransfer* tmp;
    SimpleXMLTransfer* item;
    tmp = opts->pool->getChild("shrink");
    unsigned int size = tmp->getChildCount();
    std::string descr;
    
    for (unsigned int cnt=0; cnt<size; cnt++)
    {
      item  = tmp->getChildAt(cnt);
      descr = item->attribute("w");
      descr += "x";
      descr += item->attribute("h");
      cb_size_pic->add(descr.c_str());
    }
    
    cb_size_pic->value(tmp->attributeAsInt("index"));
  }  
  sl_qual_pic->step(0.01);
  sl_qual_pic->bounds(0.4, 1.0);
  sl_qual_pic->value(opts->pool->getDouble("shrink.quality"));
  sl_qual_pic->type(FL_HOR_NICE_SLIDER);  
  
  {
    unsigned int uThumbSize = opts->pool->getDouble("export.thumbsize");
    int nIndex = -1;
    for (unsigned int n=0; TreeView::uThumbSizes[n] > 0; n++)
    {
      cb_size_thumb->add(itoStr(TreeView::uThumbSizes[n], ' ', 1).c_str());
      if (uThumbSize == TreeView::uThumbSizes[n])
        nIndex = n;
    }      
    if (nIndex >= 0)
      cb_size_thumb->value(nIndex);
  }  
  sl_qual_thumb->step(0.01);
  sl_qual_thumb->bounds(0.4, 1.0);
  sl_qual_thumb->value(opts->pool->getDouble("export.thumbqual"));
  sl_qual_thumb->type(FL_HOR_NICE_SLIDER);  
  
  
  
  switch (tmp->attributeAsInt("structure"))
  {
   case Export::eFlat:
    rb_flat->setonly();
    break;
   case Export::eFileSys:
    rb_filesys->setonly();
    break;
   default:
    rb_view->setonly();
    break;
  }
  
  this->fGroup = fGroup;

  sw_recurse     ->value(tmp->attributeAsInt("recurse"));
  sw_thumbs      ->value(tmp->attributeAsInt("thumbs"));
  sw_datafile    ->value(tmp->attributeAsInt("datafile"));
  sw_addtojpeg   ->value(tmp->attributeAsInt("addtojpeg"));
  sw_prefix      ->value(tmp->attributeAsInt("prefix", 0));
  sw_html        ->value(tmp->attributeAsInt("html",   0));
  sw_fast        ->value(tmp->attributeAsInt("fast",   0));

  // todo: Dateiformat noch nicht endgültig, also deaktivieren:
  sw_datafile->value(0);
  sw_datafile->deactivate();
  
  disp_dir->value(opts->pool->getString("export.dir").c_str());
  bt_browse->callback( (Fl_Callback*)cb_dir, (void*)disp_dir );
  disp_dir->position(strlen(disp_dir->value())-1);
  
  sw_shrink->callback( (Fl_Callback*)cb_hide_show, (void*)this );
  sw_html->callback( (Fl_Callback*)cb_hide_show, (void*)this );  
  rb_flat->callback( (Fl_Callback*)cb_hide_show, (void*)this );  
  rb_filesys->callback( (Fl_Callback*)cb_hide_show, (void*)this );  
  rb_view->callback( (Fl_Callback*)cb_hide_show, (void*)this );  
  cb_hide_show(0, (void*)this);
}

ExportDlg::~ExportDlg()
{
  delete myWindow;
}

int ExportDlg::showDlg()
{
  int nRetCode;

  myWindow->set_modal();
  myWindow->show();

  for (;;)
  {
    Fl_Widget *o = Fl::readqueue();

    if (!o)
    {
      Fl::wait();
    }
    else if (o == bt_cancel || o == myWindow)
    {
      std::cout << "cancel\n";
      nRetCode = 0;
      break;
    }
    else if (o == bt_ok)
    {
      nRetCode = 1;
      break;
    }
  }

  if (nRetCode)
  {
    SimpleXMLTransfer* tmp;
    tmp = opts->pool->getChild("export");

    if (sw_shrink->value())
      tmp->setAttributeOverwrite("type", Export::eShrink);
    else
      tmp->setAttributeOverwrite("type", Export::eCopy);

    if (rb_flat->value())
      tmp->setAttributeOverwrite("structure", Export::eFlat);
    else if (rb_filesys->value())
      tmp->setAttributeOverwrite("structure", Export::eFileSys);
    else
      tmp->setAttributeOverwrite("structure", Export::eView);

    tmp->setAttributeOverwrite("recurse",    sw_recurse     ->value());
    tmp->setAttributeOverwrite("thumbs",     sw_thumbs      ->value());
    tmp->setAttributeOverwrite("datafile",   sw_datafile    ->value());
    tmp->setAttributeOverwrite("addtojpeg",  sw_addtojpeg   ->value());
    tmp->setAttributeOverwrite("prefix",     sw_prefix      ->value());
    tmp->setAttributeOverwrite("html",       sw_html        ->value());
    tmp->setAttributeOverwrite("thumbqual",  doubleToString(sl_qual_thumb->value()));
    tmp->setAttributeOverwrite("thumbsize",  cb_size_thumb  ->text());
    tmp->setAttributeOverwrite("fast",       sw_fast        ->value());
    tmp->setAttributeOverwrite("dir",        disp_dir       ->value());
    
    tmp = opts->pool->getChild("shrink");
    tmp->setAttributeOverwrite("index",   cb_size_pic->value());
    tmp->setAttributeOverwrite("quality", doubleToString(sl_qual_pic->value()));
    

  }

  myWindow->hide();
  return(nRetCode);
}
