/*
 * Copyright (C) 2006-2007, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef EXPORTDLG_H
# define EXPORTDLG_H

# include <FL/Fl.H>
# include <FL/Fl_Double_Window.H>
# include <FL/Fl_Int_Input.H>
# include <FL/Fl_Button.H>
# include <FL/Fl_Check_Button.H>
# include <FL/Fl_Round_Button.H>
# include <FL/Fl_Return_Button.H>
# include <FL/Fl_Choice.H>
# include <FL/Fl_Value_Slider.H>
# include <FL/Fl_Output.H>
# include "optionen.h"

class ExportDlg {
  
public:
  ExportDlg(T_optionen* myopts, bool fGroup);
  ~ExportDlg();
  
  int showDlg();
  
  Fl_Check_Button* sw_shrink;
  
  Fl_Round_Button* rb_flat;
  Fl_Round_Button* rb_filesys;
  Fl_Round_Button* rb_view;
  
  Fl_Check_Button* sw_recurse;
  Fl_Check_Button* sw_thumbs;
  Fl_Check_Button* sw_datafile;
  Fl_Check_Button* sw_addtojpeg;
  Fl_Check_Button* sw_prefix;
  Fl_Check_Button* sw_html;
  Fl_Check_Button* sw_fast;
  
  Fl_Button*        bt_cancel;
  Fl_Return_Button* bt_ok;
  
  Fl_Double_Window* myWindow;
  T_optionen*       opts;

  Fl_Choice*        cb_size_pic;
  Fl_Value_Slider*  sl_qual_pic;
  Fl_Choice*        cb_size_thumb;
  Fl_Value_Slider*  sl_qual_thumb;
  
  Fl_Output* disp_dir;
  Fl_Button* bt_browse;
  
  Fl_Double_Window* make_window();
  
  Fl_Group* gr_thumb;
  Fl_Group* gr_hier;

  bool fGroup;
};
#endif
