/*
 * Copyright (C) 2008  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "exportmetadlg.h"
#include "../base/export.h"

#include <iostream>

ExportMetaDlg::ExportMetaDlg()
{
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(330, 235, "Export Metadata");
    w = o;
    { Fl_Group* o = new Fl_Group(15, 15, 300, 80);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Round_Button* o = rb_kwmerge = new Fl_Round_Button(25, 25, 280, 25, "Merge keywords");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
      }
      { Fl_Round_Button* o = rb_kwoverwrite = new Fl_Round_Button(25, 55, 280, 30, "Overwrite keywords");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
      }
      o->end();
    }
    { Fl_Check_Button* o = sw_kwinherit = new Fl_Check_Button(15, 105, 300, 30, "Inherit keywords from groups above");
      o->down_box(FL_DOWN_BOX);
    }
    { Fl_Check_Button* o = sw_comoverwrite = new Fl_Check_Button(15, 140, 295, 25, "Overwrite comment");
      o->down_box(FL_DOWN_BOX);
    }
    bt_cancel = new Fl_Button(15, 175, 130, 40, "Cancel");
    bt_ok = new Fl_Return_Button(190, 175, 125, 40, "OK");
    o->end();
  }
  
  myWindow = w;
  rb_kwmerge->setonly();
  sw_kwinherit->clear();
  sw_comoverwrite->clear();
}

ExportMetaDlg::~ExportMetaDlg()
{
  delete myWindow;
}

int ExportMetaDlg::showDlg()
{
  int nRetCode;

  myWindow->set_modal();
  myWindow->show();

  for (;;)
  {
    Fl_Widget *o = Fl::readqueue();

    if (!o)
    {
      Fl::wait();
    }
    else if (o == bt_cancel || o == myWindow)
    {
      std::cout << "cancel\n";
      nRetCode = 0;
      break;
    }
    else if (o == bt_ok)
    {
      nRetCode = 1;
      break;
    }
  }

  myWindow->hide();
  return(nRetCode);
}
