/*
 * Copyright (C) 2005, 2008, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef ITEMPROPDLG_H
# define ITEMPROPDLG_H

# include <vector>

# include <FL/Fl_Double_Window.H>
# include <FL/Fl_Input.H>
# include <FL/Fl_Output.H>
# include <FL/Fl_Button.H>
# include <FL/Fl_Text_Editor.H>

# include "../base/treeview.h"

class ItMeta;
class ItGroup;
class ItPic;

class ItemPropertyDlg
{
public:
  ItemPropertyDlg(ItPic*   myItem, TreeView* myTreeView);
  ItemPropertyDlg(ItGroup* myItem, TreeView* myTreeView);
  ~ItemPropertyDlg();
  
  /**
   * create and show the window plus error dialogs
   */
  void make_window();
      
  Fl_Double_Window*   window;
  
  int saveValues();
  
  void checkErrors();   

  void AddKw();
  
  ItGroup*   pGroup;
  ItPic*     pPic;
  ItMeta*    pMeta;
  Fl_Input*  inp_date;
  
private:
  
  Fl_Input*           inp_title;
  Fl_Input*           inp_time;
  Fl_Output*          out_linkinfo;
  Fl_Text_Editor*     inp_comment;
  Fl_Text_Editor*     inp_keywords;
  Fl_Text_Buffer*     buf_comment;
  Fl_Text_Buffer*     buf_keywords;
  Fl_Button*          btn_ID;
  Fl_Button*          btn_date;
  Fl_Button*          btn_kwadd;
  
  char                IDString[20];
  
  Fl_Button*          btn_Cancel;
  Fl_Button*          btn_OK;
  
  TreeView*           treeview;
  
  std::string         namelabel;
};
#endif
