/*
 * Copyright (C) 2008, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef kwreplacedlg_fl_h
# define kwreplacedlg_fl_h

# include <FL/Fl.H>
# include <FL/Fl_Double_Window.H>
# include <FL/Fl_Input.H>
# include <FL/Fl_Check_Button.H>
# include <FL/Fl_Button.H>
# include "texttree.h"

class ItGroup;

class KwReplaceDlg
{
public:
  KwReplaceDlg(ItGroup* group, ItGroup* root);
  ~KwReplaceDlg();
  
  void showDlg();
  
  void SetKw(int w, const char* item);
  
  Fl_Input *ti_wordold;
  Fl_Input *ti_wordnew;
  Fl_Check_Button *cb_wholeword;
private:
  TextTreeBrowser* brw_kwfrom;
  TextTreeBrowser* brw_kwto;
  Fl_Button *btn_replace;
  Fl_Button *btn_close;
  Fl_Double_Window* myWindow;
  ItGroup* group;
  ItGroup* root;
};
#endif
