/*
 * Copyright (C) 2005-2006, 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef OPTIONEN_H
# define OPTIONEN_H

# include <vector>
# include <string>

# include "../shared/SimpleXMLTransfer.h"

class T_optionen
{
  public:
   T_optionen(const char* mypath);
   ~T_optionen();
   void addRecentFile(const char* fname);
   void removeRecentFile(const char* fname);
   int  recentFilesCnt() { return(recentFiles.size()); };
   std::string recentFile(unsigned int nNr);

   /**
    * Width of window
    */
   int   nWinWidth;

   /**
    * Height of window
    */
   int   nWinHeight;
   
   /**
    * Width of tree browser
    */
   int   nTreeWidth;
   
   /**
    * Height of font in pixel
    */   
   int   nFontSize;
   
   /**
    * Size of thumbnail in pixel
    */
   unsigned int  uThumbSize;
   
   /**
    * Aspect ratio for image display (usually 1.0. CRT with 1280x1024: 0.931)
    */
   float flAspectRatio;
   
   /**
    * Create Thumbnails?
    */
   bool fCreateThumbs;
   
   /**
    * This variable is -1 when the config file could not be loaded.
    * Otherwise, it will increment on every launch of the application,
    * wrapping around at 2^16.
    */
   int nStartCnt;

   /**
    * Show initial help window?
    */
   bool fShowInitialHelp;
   
   /**
    * UI Style
    */
   std::string UIStyle;

   static const char* UIStyles[];
   
   int getNrOfStyles();
  
   /**
    * The lazy way.
    */
   SimpleXMLTransfer* pool;

   SimpleXMLTransfer* getShrink();

  private:
   std::vector<std::string> recentFiles;
   std::string              path;   
};

#endif
