/*
 * Copyright (C) 2005-2006, 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef optsdlg_h
# define optsdlg_h

# include <FL/Fl.H>
# include <FL/Fl_Double_Window.H>
# include <FL/Fl_Int_Input.H>
# include <FL/Fl_Float_Input.H>
# include <FL/Fl_Choice.H>
# include <FL/Fl_Button.H>
# include <FL/Fl_Check_Button.H>
# include <FL/Fl_Return_Button.H>
# include <FL/Fl_Value_Slider.H>

# include "optionen.h"

class OptsDlg {

public:
  OptsDlg(T_optionen* myopts);
  ~OptsDlg();

  int showDlg();

private:
  Fl_Int_Input*    inp_fontsize;
  Fl_Choice*       cb_thumbsize;
  Fl_Float_Input*  inp_aspectratio;
  Fl_Check_Button* sw_thumbs;
  Fl_Check_Button* sw_initialHelp;
  Fl_Choice*       cb_UIStyle;

  Fl_Choice*        cb_shrinkmode;
  Fl_Value_Slider*  sl_shrinkqual;

  Fl_Choice*        cb_DispSpeedQual;

  Fl_Button*        btn_cancel;
  Fl_Return_Button* btn_ok;
  Fl_Double_Window* myWindow;
  T_optionen*       opts;
  
  Fl_Double_Window* make_window();
};
#endif
