/*
 * Copyright (C) 2005, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef PICBUTTON_H
# define PICBUTTON_H

# include <FL/Fl_Button.H>
# include <string>

class ItPicInGroup;

class PicButton : public Fl_Button
{
public:
  enum eCallback { SHOW, CONTEXT };
  PicButton(int,int,int,int, const char * = 0);
  virtual ~PicButton();
  int handle(int);
  void draw();      
  void item(ItPicInGroup* p);
  
  void redrawIf(ItPicInGroup* ptr);
  ItPicInGroup* myPic;
  
  /**
   * This is because FLTK 1.1 in debian sarge doesn't implement Fl_Widget::copy_label()
   */
  void setLabel(std::string somestring);
  
  /**
   * mouse coordinate when activating context menu
   */
  int nMX;
  int nMY;
  
private:
  /**
   *
   */
  std::string mylabel;   
};
#endif
