/*
 * Copyright (C) 2005, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef PICGROUP_H
# define PICGROUP_H

# include <FL/Fl_Scroll.H>

# include "textbox.h"

class ItPicInGroup;

class PicGroup : public Fl_Scroll
{
public:
  PicGroup(int,int,int,int, const char *);
  virtual ~PicGroup();
  virtual void resize(int x, int y, int w, int h);
  void draw();
  void setDescr(std::string newdescr);
  void clear();
  
  
private:  
  TextBox*  textbox;   
  
  ///@{
  ///@name mark items
public:
  /**
   * Shift+Click on item "pPic"
   */
  void ClickShift(ItPicInGroup* pPic);

  void ClickCtrl(ItPicInGroup* pPic);
private:  
  /**
   * Stores a pointer to the item which was the last one
   * (un)marked with ctrl+left click.
   */
  ItPicInGroup* pClickCtrl;
  
  /**
   * Stores a pointer to the item which was the last one 
   * in a range marked with shift+left click.
   */
  ItPicInGroup* pClickShift;
  ///@}
  
};

#endif
