/*
 * Copyright (C) 2005, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef PICTREEBROWSER_H
# define PICTREEBROWSER_H

# include <FL/Fl_Browser_.H>
# include "../base/treeview.h"

class ItGroup;
class UserInterface;

class PicTreeBrowser : public Fl_Browser_
{
  // required routines for Fl_Browser_ subclass:
  void *item_first() const ;
  void *item_next(void *) const ;
  void *item_prev(void *) const ;
  int  item_width(void *) const ;
  int  item_height(void *) const ;
  void item_draw(void *,int,int,int,int) const ;
  
  
  
public:	   
  int handle(int);
  PicTreeBrowser(int,int,int,int,const char *);
  
  void      textsize(uchar s);
  ItGroup* itemSelected;
  UserInterface* pGUI;
  
  
  
private:
  TreeView* treeview;
public:
  void setData(TreeView* tv) { treeview = tv; };
  
  
private:
  
  /**
   * 
   */
  int nItemHeight;
  
  /**
   * 
   */
  int nSizeBox;
  
  /**
   * 
   */
  int nLengthDash;
  
  /**
   * 
   */
  int nD;
  
  /**
   * copy of int Fl_Browser_::textsize()
   */
  int nTextsize;
  
  /**
   * 
   */
  int nGroupAdd;
};

#endif
