/*
 * Copyright (C) 2005, 2008, 2012  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef searchdlg_h
# define searchdlg_h

# include <set>
# include <string>
# include <FL/Fl.H>
# include <FL/Fl_Double_Window.H>
# include <FL/Fl_Input.H>
# include <FL/Fl_Check_Button.H>
# include <FL/Fl_Button.H>
# include <FL/Fl_Return_Button.H>
# include <FL/Fl_Help_Dialog.H>

# include "texttree.h"
# define KWSRCHBROWSER TextTreeBrowser

class ItGroup;
class TreeView;

/**
 * 
 */
class SearchDlg {
public:
  SearchDlg(std::set<std::string>& kwset, TreeView* pTreeView, ItGroup* pSrc);
  ~SearchDlg();
  
  int showDlg();
  
  void AddKw(const char* item);
  void SetSource(const char* srcID);
  
  Fl_Input *inp_name;
  Fl_Input *ti_expr;
  Fl_Check_Button*  cb_flat;
  ItGroup* pSrcGroup;
  Fl_Help_Dialog* pLog;
private:
  Fl_Button*        btn_cancel;
  Fl_Return_Button* btn_search;
  Fl_Button*        btn_src;
  Fl_Button*        btn_help;
  Fl_Button*        btn_explain;
  Fl_Double_Window* myWindow;
  
  KWSRCHBROWSER*    brw_kws;
  char* pNameStr;
  
  TreeView* pTreeView;
};
#endif
