/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef TEXTBOX_H
#define TEXTBOX_H

#include <string>
#include <vector>
#include <FL/Fl_Box.H>

struct TTextBoxLinkData
{
  int x;
  int y;
  int w;
  std::string dest;
};

class TextBox : public Fl_Box
{
  public:
   TextBox(int,int,int,int, const char * = 0);
   virtual ~TextBox();
   int handle(int);
   
   virtual void resize(int x, int y, int w, int h);
   
   void recalcLayoutInto(int x, int y, int w, int h);
   
   void draw();
   void setDescr(const char* newdescr);
   
   std::string getLinkText();
   
   bool  fMarked;
   
  private:
   
   enum eConst { eRAND = 3 };
   
   /**
    * text to be displayed
    */
   std::string descr;
   
   /**
    * has the text layout been calculated?
    */
   bool fTextLayoutDone;

   /**
    * width of text
    */
   unsigned int uTextWidth;
   
   /**
    * height of text
    */
   unsigned int uTextHeight;

   /**
    * Calculate layout and (maybe) print to screen
    */
   void doTextLayout(bool fPrint,
                     int  nW = -1);
  
   unsigned int LayoutPrint(bool fPrint,
                            Fl_Color& textcolor,
                            std::string   strText,
                            int  nX0,     int nY0,
                            int  nW,      int nWMax,
                            unsigned int& uWidth);
     
   /**
    * links
    */
   std::vector<TTextBoxLinkData> links;
   
   /**
    * 
    */
   bool fLinkCursor;
   
   /**
    * 
    */
   int nClickedLink;
};
#endif
