/*
 * Copyright (C) 2008  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef TEXTTREEBROWSER_H
# define TEXTTREEBROWSER_H

# include <string>
# include <FL/Fl_Browser_.H>

class TextTreeItem;
class TextTreeBrowser : public Fl_Browser_
{
  // required routines for Fl_Browser_ subclass:
  void *item_first() const ;
  void *item_next(void *) const ;
  void *item_prev(void *) const ;
  int  item_width(void *) const ;
  int  item_height(void *) const ;
  void item_draw(void *,int,int,int,int) const ;
  
  
  
public:	   
  int handle(int);
  TextTreeBrowser(int,int,int,int,const char *, TextTreeItem*);
  virtual ~TextTreeBrowser();
  void      textsize(uchar s);

  std::string selected_path;

  void delData();
  void setData(TextTreeItem*);
  
  void show(std::string text);
  
  TextTreeItem* getSelectedItem();
  
private:
  
  /**
   * 
   */
  int nItemHeight;
  
  /**
   * 
   */
  int nSizeBox;
  
  /**
   * 
   */
  int nLengthDash;
  
  /**
   * 
   */
  int nD;
  
  /**
   * copy of int Fl_Browser_::textsize()
   */
  int nTextsize;
  
  /**
   * 
   */
  int nGroupAdd;
  
  TextTreeItem* data;
};

#endif
