#include "useriddlg.h"

#include <iostream>
#include "../base/user.h"
#include "misc.h"

void cb_uid_close(Fl_Widget* widget, void* userdata)
{
  // force the user to click "cancel" or "apply"
}

void cb_uid_help(Fl_Widget* widget, void* userdata)     
{
  GUIMisc::OpenHelp("", "fa_ht_multiuser.htm"); // using an anchor here seems not to work (at least with an external browser)
}

void cb_uid_cancel(Fl_Widget* widget, void* userdata)     
{
  UserIDDlg* pDlg = (UserIDDlg*)userdata;
  
  pDlg->w->hide();
  Fl::delete_widget(pDlg->w);
}

void cb_uid_ok(Fl_Widget* widget, void* userdata)     
{
  UserIDDlg* pDlg = (UserIDDlg*)userdata;
  
  std::string strVal = pDlg->cb_userid->text();
  std::string::size_type pos = strVal.find(":");
  if (pos == 1)
    pDlg->pUser->SetUserID(strVal.substr(0, 1));
  
  cb_uid_cancel(widget, userdata);
}

Fl_Double_Window* UserIDDlg::make_window()
{
  { Fl_Double_Window* o = new Fl_Double_Window(590, 410, "Assign user ID");
    w = o;
    { info = new Fl_Text_Display(15, 15, 555, 290);
    } // Fl_Text_Display* info
    { cb_userid = new Fl_Choice(225, 320, 350, 25);
      cb_userid->down_box(FL_BORDER_BOX);
    } // Fl_Choice* cb_userid
    { bt_help = new Fl_Button(15, 360, 100, 35, "Help");
    } // Fl_Button* bt_help
    { bt_cancel = new Fl_Button(360, 360, 100, 35, "Cancel");
    } // Fl_Button* bt_cancel
    { bt_ok = new Fl_Button(475, 360, 100, 35, "OK");
    } // Fl_Button* bt_ok
    o->end();
  } // Fl_Double_Window* o
  
  
  // fill info box
  Fl_Text_Buffer* buf = new Fl_Text_Buffer();
  info->buffer(buf);
  buf->append("Your combination of user- and hostname is new to this file.\n"
              "In order to be able to add groups, pictures and ratings,\n"
              "you need to have a user ID.\n"
              "Using an ID which is not in use yet is the safest option\n"
              "and you should do so unless you really know better,\n"
              "but there are reasons to share an ID with another user.\n");
  
  // fill combo box, select first item
  std::vector<std::string> vList = pUser->GetUserList();
  for (unsigned int n=0; n<vList.size(); n++)
    cb_userid->add(vList[n].c_str());
  cb_userid->value(0);
  
  w->set_modal();
  w->show();  
  w->callback((Fl_Callback*)cb_uid_close, (void*)this );
  bt_ok->callback( (Fl_Callback*)cb_uid_ok, (void*)this );
  bt_cancel->callback( (Fl_Callback*)cb_uid_cancel, (void*)this );
  bt_help->callback( (Fl_Callback*)cb_uid_help, (void*)this );
  
  return w;
}

UserIDDlg::UserIDDlg(User* pUser)
{
  this->pUser = pUser;
}

