/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "workerdlg.h"
#include "../config.h"

#include <iostream>

WorkerDlg::WorkerDlg(WorkerData* myWD)
{  
  wd = myWD;
  
  { 
    Fl_Double_Window* o = worker_form = new Fl_Double_Window(350, 140, "Waiting for worker to finish...");
    o->box(FL_FLAT_BOX);
    o->color(FL_BACKGROUND_COLOR);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(0);
    o->labelsize(14);
    o->labelcolor(FL_BLACK);
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    progressbar = new Fl_Progress(40, 30, 275, 25);
    btnCancel = new Fl_Button(95, 85, 175, 35, "Cancel");
    o->end();
  }
}

WorkerDlg::~WorkerDlg()
{
  delete worker_form;
}

void WorkerDlg::showDlg()
{
  unsigned int uDone   = 0;
  bool         fCancel = false;
  
  worker_form->set_modal();
  worker_form->show();
  
  progressbar->value(0);
  progressbar->minimum(0);
  progressbar->maximum(wd->uNumToHandle);
    
  while (wd->nRun && !fCancel)
  {
    Fl_Widget *o = Fl::readqueue();
    
    if (!o) 
    {
      Fl::wait(1);
    }
    else if (o == btnCancel || o == worker_form)
    {
      fCancel = true;
    }
    
    if (wd->uNumUnitsDone != uDone)
    {
      uDone = wd->uNumUnitsDone;
      // Update display
      progressbar->value(uDone);
    }
  }

  // stop worker
  if (wd->nRun)
    wd->nStop = 1;
  std::cout << "dlg finished A\n";
  std::cout.flush();  
  
  worker_form->hide();
}

