/**
 * This files' content is taken from the net and modified by JWW.
 * 
 * I found it on stackoverflow while searching for a way to use a
 * std::istream and std::ostream with a FILE (needed for WIN32);
 * gcc's extension __gnu_cxx::stdio_filebuf<char> lead to strange
 * errors on WIN32.
 * 
 * The code was said to come from the french FAQ of fr.comp.lang.c++
 */
#include "filestream.h"

FILEbuf::int_type FILEbuf::overflow(int_type c)
{
  if (traits_type::eq_int_type(c, traits_type::eof())) 
  {
    // la norme ne le demande pas exactement, mais si on nous passe eof
    // la coutume est de faire la meme chose que sync()
    return (sync() == 0
        ? traits_type::not_eof(c)
        : traits_type::eof());
  }
  else 
  {
    return ((fputc(c, cstream_) != EOF)
        ? traits_type::not_eof(c)
        : traits_type::eof());
  }
}


FILEbuf::int_type FILEbuf::underflow()
{
  // Assurance contre des implementations pas strictement conformes a la
  // norme qui guaranti que le test est vrai.  Cette guarantie n'existait
  // pas dans les IOStream classiques.
  if (gptr() == NULL || gptr() >= egptr()) 
  {
    int gotted = fgetc(cstream_);
    if (gotted == EOF) 
    {
      return traits_type::eof();
    } 
    else 
    {
      *inputBuffer_ = gotted;
      setg(inputBuffer_, inputBuffer_, inputBuffer_+1);
      return traits_type::to_int_type(*inputBuffer_);
    }
  } 
  else
  {
    return traits_type::to_int_type(*inputBuffer_);
  }
}
