/*
 * Copyright (C) 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */
#ifndef IMGXFORM_H
# define IMGXFORM_H

namespace ImgXForm
{
   /**
    * nearest-neighbor algorithm
    */
   unsigned char* Sample(const unsigned char* in, int nWIn, int nHIn, int nCh,
                         int nWOut, int nHOut);
   
   /**
    * bilinear scaling
    */
   unsigned char* Bilinear(const unsigned char* in, int nWIn, int nHIn, int nCh,
                           int nWOut, int nHOut);
   
   /**
    * Scales down by calculating arithmetic mean.
    * Up to (nDiv-1) pixel at the border may not show up in the result.
    * 
    * May be needed for very big shrink ratios or PNGs (loader does not scale down).
    */
   unsigned char* Shrink(const unsigned char* in, int& nWIn, int& nHIn, int nCh,
                         int nDiv);

};

#endif
