/*
 * Copyright (C) 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */
#ifndef READJPEG_H
# define READJPEG_H

/**
 * Loads and decodes jpeg file. Uses fast downscaling to return a pixel
 * array as small as possible, but at least a size of (nWMin x nHMin)  
 * unless the original image is smaller.
 * The size is returned in nWMin and nHMin.
 * Shrink ratio is returned in nRatio.
 */
unsigned char* LoadScaledJPEG(const char *jpeg, int& nWMin, int& nHMin, int& nRatio);

/**
 * nW: width
 * nH: height
 * nD: bytes per pixel
 * nQuality: 0..100
 */
int WriteJPEG(const char* filename, unsigned char* data, int nW, int nH, int nD, int nQuality);

#endif
