// -*- mode: c; mode: fold -*-

/*
 * Copyright (C) 2003-2005, 2009  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef SCANDIR_H
#define SCANDIR_H

#include <string>
#include <vector>

#ifdef SCAN_FLTK
# include <FL/filename.H>
#endif

#ifndef WIN32
# include <dirent.h>     // für die Verzeichnisoperationen
#endif

class ScanDir
{
  public:
   ScanDir(const char *d);
   ~ScanDir();

   /**
    * Find a file basename.* in dir
    */
   static std::string findBasenameInDir(std::string basename, 
                                        std::string dir);
   static void        findBasenameInDir(std::string basename, 
                                        std::string dir,
                                        std::vector<std::string>& res);
      
   static void        findInDir(std::string               dir,
                                bool                      fRecursive,
                                std::vector<std::string>& res);
      
   dirent** list;
   int      nNrEntries;
};

 

#endif
