/*
 * Copyright (C) 2010  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */
#include "template.h"

#include <fstream>

const char* TemplateException::what()
{
  return (myMessage.c_str());
}

TemplateException::TemplateException(std::string message)
{
  myMessage = message;
}

Template::Template(std::string filename)
{
  std::string buf = "";
  char inchar;
  bool fNorm = true;
  
  std::ifstream in;
  in.open(filename.c_str());
  
  if (!in)
  {
    throw TemplateException("Error opening " + filename);
  }
  
  while (!in.eof())
  {
    inchar = in.get();
    if (!in.eof())
    {
      if (fNorm)
      {
        if (inchar == '{')
        {
          list.push_back(TemplateEntry(buf));
          buf = inchar;
          fNorm = false;
        }
        else
          buf += inchar;
      }
      else
      {
        buf += inchar;
        if (inchar == '}')
        {
          list.push_back(TemplateEntry(buf));
          buf = "";
          fNorm = true;
        }
      }    
    }
  }
  list.push_back(TemplateEntry(buf));
  
  in.close();
}

