/*
 * Copyright (C) 2010  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */
#ifndef TEMPLATE_H
# define TEMPLATE_H

# include <string>
# include <vector>

class TemplateException
{
public:
  /**
   * Create a new Exception with a given <code>message</code>.
   */
  TemplateException(std::string message);
  
  /**
   * Return a <code>const char*</code> to the exception's message.
   */
  const char* what();
  
private:
  std::string myMessage;
};


class TemplateEntry
{
public:
  TemplateEntry(std::string val)
  {
    if (val.length() && val[0] == '{')
      nID = 0;
    else
      nID = 1;
    value = val;
  }
  
  int nID;
  std::string value;
};

/**
 * Reads a template file. Variable entries get nID=0, usual entries nID=1.
 */
class Template
{
public:
  Template(std::string filename);
  
  std::vector<TemplateEntry> list;
};

#endif
