/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "textparser.h"

void TextParser::setText(std::string newtxt)
{
  txt   = newtxt;
  start = 0;
  fMore = (newtxt.length() > 0);
  fLink = false;
}

bool TextParser::hasToken()
{
  return(fMore);
}

void TextParser::getToken(std::string& token,
                          bool&        fNewLine)
{
  std::string::size_type pos;
  std::string::size_type s;
  std::string::size_type l;
  
  fNewLine = false;
  
  if (fLink)
  {
    pos = txt.find('>', start);
    if (pos == std::string::npos)
    {
      // todo: error
      fMore = false;
      token = txt.substr(start);
    }
    else
    {
      fLink = false;
      s     = start;
      l     = pos-start;
      start = pos+1;
      if (l == 0)
        token = "";
      else
        token = "<" + txt.substr(s, l) + ">";
    }
  }
  else
  {  
    
    pos = txt.find_first_of(" \n<", start);
  
    if (pos == std::string::npos)
    {
      fMore = false;
      token = txt.substr(start);
    }
    else
    {
      s     = start;
      l     = pos-start;
      
      if (txt[pos] == '<')
      {
        fLink = true;
      }
      else if (txt[pos] == '\n' && l == 0)
        fNewLine = true;

      if (txt[pos] != '\n' || l == 0)
        start = pos+1;
      else
        start = pos;
      
      if (l == 0)
        token = "";
      else
        token = txt.substr(s, l);
    }  
  }
}
