/*
 * Copyright (C) 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef SIMPLETHREAD_H
# define SIMPLETHREAD_H

# ifdef WIN32
#  include <windows.h>
#  include <process.h>   
# else
#  include <pthread.h>
# endif

/**
 * Methods to start and exit a thread. 
 * Being able to adjust a threads priority would be helpful, but 
 * that requires root privileges on linux (realtime priority is needed
 * to use pthread_setschedprio()).
 */
namespace SimpleThread
{
   /**
    * Return zero on success
    */
   int Create(void *(*f) (void *), void* p);
   
   void Exit();
};

#endif
