/*
 * Copyright (C) 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef UTF8_H
# define UTF8_H

#include <string>

/**
 * Some unctions in this namespace are quite simple -- they don't know anything about
 * most of the "Unicode Characters in the 'Separator, Space' Category":
 * http://www.fileformat.info/info/unicode/category/Zs/list.htm
 */
namespace UTF8
{
   /**
    * Only returns true for characters below 0x80 and therefore never
    * for multibyte UTF-8 characters.
    */
   bool isspace(int nChar);
   
   /**
    * Removes leading and trailing whitespace.
    */
   std::string trim(std::string in);

   /**
    * Collapses consecutive whitespace to a single space.
    */
   std::string collapse_space(std::string in);

   /**
    * returns lower case string
    */
   std::string to_lower(std::string in);
};

#endif
